# Dire cosa stampa a video il seguente programma assembler,
# qualora vengano fornite in ingresso la terzultima e
# l'ultima cifra del proprio numero di matricola

_main:  MOV   $4, %DH
        MOV   $0, %AH
        CALL  inbyte
        AND   $0x0F, %AL
        CALL  outbyte
lab1:   SHR   $1, %AL
        JNC   lab2
        INC   %AH
lab2:   DEC   %DH
        JZ    lab3
        JMP   lab1       
lab3:   CMP   $1, %AH
        JE    lab4
        MOV   $'N', %AL        
        JMP   fine
lab4:   MOV   $'S', %AL
fine:   CALL  output
        RET

.INCLUDE "utility"



# PROMEMORIA
#
# CALL inbyte   Legge da tastiera due caratteri (purch compresi fra '0' e '9' oppure fra 'A' e 'F'),
#               li interpreta come cifre esadecimali e li utilizza per inizializzare AL
#               Esempio: qualora venissero inseriti '4' e 'B' in %AL ci finirebbe 0100-1011 (0x4B).
#
# CALL outbyte  Stampa a video le due cifre esadecimali associate al contenuto del registro AL.
#               Esempio: Se AL contiene 0100-1011, stamper a video "4B".
#
# SHR $1, REG   Effettua lo shift a destra del contenuto del registro REG di 1 posto.
#               Il bit meno significativo finisce nel carry flag. Da sinistra entra un bit a zero.
#
# JNC label     Salta a 'label' tutte le volte in cui l'ultima operazione NON ha settato il carry flag.
#
# CALL output   Stampa a video il carattere ASCII la cui codifica si trova in AL.
#               Esempio: qualora in AL si trovasse 0011-0101 stamperebbe a video il carattere '5'.
#
# CMP IMM,REG   Confronta l'operando immediato IMM con il contenuto del registro REG
# 
# JE label      Salta a 'label' solo se i due operandi confrontati nella precedente istruzione CMP 
#               erano uguali
